diff -bruN freeswan-1.9.orig/pluto/state.h freeswan-1.9/pluto/state.h
--- freeswan-1.9.orig/pluto/state.h	Tue Jan 30 16:58:36 2001
+++ freeswan-1.9/pluto/state.h	Wed Jun  6 15:52:29 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: state.h,v 1.49 2001/01/30 21:58:36 dhr Exp $
+ * RCSID $Id: state.h,v 1.51 2001/03/02 03:19:46 dhr Exp $
  */
 
 #include <sys/types.h>
@@ -126,7 +126,6 @@
     u_int32_t          st_doi;                 /* Domain of Interpretation */
     u_int32_t          st_situation;
 
-    bool               st_pending_quick;       /* need to build IPsec SA after ISAKMP SA */
     lset_t             st_policy;              /* policy for IPsec SA */
 
     msgid_t            st_msgid;               /* MSG-ID from header.  Network Order! */
@@ -146,6 +145,15 @@
     u_int8_t           st_rcookie[COOKIE_SIZE];/* Responder Cookie */
     chunk_t            st_nr;                  /* Nr nonce */
 
+#ifdef OPENSSL
+    /* key material for revised public key information */
+    u_int8_t           st_ne_i_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_i;                /* key for initiator payloads */
+    keysched           st_ks_i;
+    u_int8_t           st_ne_r_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_r;                /* key for responder payloads */
+    keysched           st_ks_r;
+#endif
 
   /* my stuff */
 
@@ -180,7 +188,7 @@
                                                 * selected.
                                                 */
 
-    u_int16_t          st_state;               /* State of exchange */
+    enum state_kind    st_state;               /* State of exchange */
     u_int8_t           st_retransmit;          /* Number of retransmits */
     unsigned long      st_try;                 /* number of times rekeying attempted */
                                                /* 0 means the only time */
@@ -205,7 +213,7 @@
 
 extern u_int16_t pluto_port;	/* Pluto's port */
 
-extern void connection_discard(struct connection *c);
+extern bool states_use_connection(struct connection *c);
 
 /* state functions */
 
@@ -226,7 +234,7 @@
 	const ip_address *peer,
 	msgid_t msgid),
     *state_with_serialno(so_serial_t sn),
-    *find_isakmp_sa(const struct connection *c);
+    *find_phase1_state(const struct connection *c);
 
 extern void show_states_status(void);
 
diff -bruN freeswan-1.9.orig/pluto/timer.c freeswan-1.9/pluto/timer.c
--- freeswan-1.9.orig/pluto/timer.c	Sun Dec 17 17:05:12 2000
+++ freeswan-1.9/pluto/timer.c	Wed Jun  6 15:56:33 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: timer.c,v 1.60 2000/12/17 22:05:12 dhr Exp $
+ * RCSID $Id: timer.c,v 1.64 2001/05/28 19:18:20 dhr Exp $
  */
 
 #include <stdio.h>
@@ -33,6 +33,7 @@
 #include "packet.h"
 #include "demux.h"  /* needs packet.h */
 #include "ipsec_doi.h"	/* needs demux.h and state.h */
+#include "kernel.h"
 #include "server.h"
 #include "log.h"
 #include "rnd.h"
@@ -69,7 +70,7 @@
  * This routine places an event in the event list.
  */
 void
-event_schedule(int type, time_t tm, struct state *st)
+event_schedule(enum event_type type, time_t tm, struct state *st)
 {
     struct event *ev = alloc_thing(struct event, "struct event in event_schedule()");
 
@@ -198,6 +199,11 @@
 	    init_secret();
 	    break;
 
+        case EVENT_SHUNT_SCAN:
+            passert(st == NULL);
+            scan_proc_shunts();
+            break;
+
 	case EVENT_RETRANSMIT:
 	    /* Time to retransmit, or give up.
 	     *
@@ -255,6 +261,8 @@
 		    case STATE_MAIN_I1:
 			details = ".  No acceptable response to our first IKE message";
 			break;
+		    default:
+                        break;
 		    }
 		    loglog(RC_NORETRANSMISSION
 			, "max number of retransmissions (%d) reached %s%s"
@@ -279,7 +287,7 @@
 			    /* Release whack because the observer will get bored. */
 			    loglog(RC_COMMENT, "%s, but releasing whack"
 				, story);
-			    release_whack(st);
+			    release_pending_whacks(st, story);
 			}
 			else
 			{
diff -bruN freeswan-1.9.orig/pluto/timer.h freeswan-1.9/pluto/timer.h
--- freeswan-1.9.orig/pluto/timer.h	Sun Aug 13 21:21:41 2000
+++ freeswan-1.9/pluto/timer.h	Wed Jun  6 15:57:55 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: timer.h,v 1.11 2000/08/14 01:21:41 dhr Exp $
+ * RCSID $Id: timer.h,v 1.12 2001/05/28 19:18:20 dhr Exp $
  */
 
 extern time_t now(void);	/* careful version of time(2) */
@@ -26,7 +26,7 @@
     struct event   *ev_next;        /* Pointer to next event */
 };
 
-extern void event_schedule(int type, time_t tm, struct state *st);
+extern void event_schedule(enum event_type type, time_t tm, struct state *st);
 extern void event_handle(void);
 extern long next_event(void);
 extern void delete_event(struct state *st);
diff -bruN freeswan-1.9.orig/pluto/version.c freeswan-1.9/pluto/version.c
--- freeswan-1.9.orig/pluto/version.c	Mon Feb 26 18:56:08 2001
+++ freeswan-1.9/pluto/version.c	Thu Jun  7 14:54:02 2001
@@ -1,2 +1,2 @@
-/* silly pointless RCSID $Id: version.c,v 1.17.2.1 2001/02/26 23:56:08 henry Exp $ */
-static const char freeswan_version[] = "1.9";
+/* silly pointless RCSID $Id: version.c,v 1.19 2001/05/30 13:02:20 henry Exp $ */
+static const char freeswan_version[] = "FreeSWAN-1.9-pkix2";
diff -bruN freeswan-1.9.orig/pluto/whack.c freeswan-1.9/pluto/whack.c
--- freeswan-1.9.orig/pluto/whack.c	Wed Jan 31 20:54:09 2001
+++ freeswan-1.9/pluto/whack.c	Wed Jun  6 16:09:39 2001
@@ -1,4 +1,6 @@
 /* command interface to Pluto
+ *
+ * Modified by Luc Lanthier based on work from:
  * Copyright (C) 1997 Angelos D. Keromytis.
  * Copyright (C) 1998, 1999  D. Hugh Redelmeier.
  *
@@ -12,7 +14,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: whack.c,v 1.72 2001/02/01 01:54:09 dhr Exp $
+ * RCSID $Id: whack.c,v 1.77 2001/05/14 20:37:48 dhr Exp $
  */
 
 #include <stdio.h>
@@ -82,6 +84,10 @@
 	    " [--compress]"
 	    " [--tunnel]"
 	    " [--pfs]"
+#ifdef OPENSSL
+	    " [--openssl]"
+#endif
+
 	    " \\\n   "
 	    " [--ikelifetime <seconds>]"
 	    " [--ipseclifetime <seconds>]"
@@ -90,6 +96,14 @@
 	    " [--reykeyfuzz <percentage>]"
 	    " \\\n   "
 	    " [--keyingtries <count>]"
+#ifdef OPENSSL
+	    " \\\n   "
+	    " [--certfile <file name>]"
+	    " [--certopts <[!]opt1,[!]opt2,...,[!]optN>]"
+	    " [--peerfile <file name>]"
+	    " [--keyfile <file name>]"
+	    " [--certpath <file name>]"
+#endif
 	    "\n\n"
 	"routing: whack"
 	    " (--route | --unroute)"
@@ -142,6 +156,9 @@
 	"shutdown: whack"
 	    " --shutdown"
 	    "\n\n"
+	"DES type: whack"
+	    " [--force_encrypt_cypher <des/3des>]"
+	    "\n\n"
 	"FreeS/WAN %s\n",
 	freeswan_version);
 }
@@ -203,6 +220,14 @@
     OPT_KEYID,
     OPT_PUBKEYRSA,
 
+#ifdef OPENSSL
+    OPT_CERTFILE,
+    OPT_CERTOPTS,
+    OPT_PEERFILE,
+    OPT_KEYFILE,
+    OPT_CERTPATH,
+#endif
+
     OPT_ROUTE,
     OPT_UNROUTE,
 
@@ -234,17 +259,26 @@
 
 #   define CD_POLICY_FIRST  CD_PSK
     CD_PSK,	/* same order as POLICY_* */
+#ifndef OPENSSL
     CD_RSASIG,	/* same order as POLICY_* */
+#else
+    CD_OPENSSL,	/* same order as POLICY_* */
+#endif
     CD_ENCRYPT,	/* same order as POLICY_* */
     CD_AUTHENTICATE,	/* same order as POLICY_* */
     CD_COMPRESS,	/* same order as POLICY_* */
     CD_TUNNEL,	/* same order as POLICY_* */
     CD_PFS,	/* same order as POLICY_* */
+
+    CD_FAIL_PASS,	/* same order as POLICY_* */
+    CD_FAIL_DROP,
     CD_TUNNELIPV4,
     CD_TUNNELIPV6,
     CD_CONNIPV4,
     CD_CONNIPV6,
 
+    CD_FORCE_ENCRYPT_CYPHER,   /* to force DES or 3DES only */
+
     CD_IKELIFETIME,
     CD_IPSECLIFETIME,
     CD_RKMARGIN,
@@ -317,7 +351,12 @@
     { "updown", required_argument, NULL, CD_UPDOWN + OO },
 
     { "psk", no_argument, NULL, CD_PSK + OO },
+#ifndef OPENSSL
     { "rsasig", no_argument, NULL, CD_RSASIG + OO },
+#else
+    { "rsasig", no_argument, NULL, CD_OPENSSL + OO },
+    { "openssl", no_argument, NULL, CD_OPENSSL + OO },
+#endif
 
     { "encrypt", no_argument, NULL, CD_ENCRYPT + OO },
     { "authenticate", no_argument, NULL, CD_AUTHENTICATE + OO },
@@ -326,6 +365,8 @@
     { "tunnelipv4", no_argument, NULL, CD_TUNNELIPV4 + OO },
     { "tunnelipv6", no_argument, NULL, CD_TUNNELIPV6 + OO },
     { "pfs", no_argument, NULL, CD_PFS + OO },
+    { "pass", no_argument, NULL, CD_FAIL_PASS + OO },
+    { "drop", no_argument, NULL, CD_FAIL_DROP + OO },
     { "ipv4", no_argument, NULL, CD_CONNIPV4 + OO },
     { "ipv6", no_argument, NULL, CD_CONNIPV6 + OO },
 
@@ -335,6 +376,16 @@
     { "rekeywindow", required_argument, NULL, CD_RKMARGIN + OO + NUMERIC_ARG },	/* OBSOLETE */
     { "rekeyfuzz", required_argument, NULL, CD_RKFUZZ + OO + NUMERIC_ARG },
     { "keyingtries", required_argument, NULL, CD_KTRIES + OO + NUMERIC_ARG },
+/* DES Support */
+    { "force_encrypt_cypher", required_argument, NULL, CD_FORCE_ENCRYPT_CYPHER + OO },
+
+#ifdef OPENSSL
+    { "certfile", required_argument, NULL, OPT_CERTFILE + OO },
+    { "certopts", required_argument, NULL, OPT_CERTOPTS + OO },
+    { "peerfile", required_argument, NULL, OPT_PEERFILE + OO },
+    { "keyfile", required_argument, NULL, OPT_KEYFILE + OO },
+    { "certpath", required_argument, NULL, OPT_CERTPATH + OO },
+#endif
 
 #ifdef DEBUG
     { "debug-none", no_argument, NULL, DBGOPT_NONE + OO },
@@ -418,7 +469,7 @@
     if (default_nexthop)
     {
 	if (isanyaddr(&that->host_addr))
-	    diag("nexthop must be specified when other host is a Road Warrior");
+	    diag("nexthop must be specified when other host is a %any or %opportunistic");
 	this->host_nexthop = that->host_addr;
     }
 
@@ -439,7 +490,11 @@
 	    /* client is 0.0.0.0/32: Opportunism connection */
 	    if (!isanyaddr(&this->host_addr))
 		diag("normal client network must not be 0.0.0.0/32 or 0::0/128");
+#ifndef OPENSSL
 	    if ((policy & (POLICY_PSK | POLICY_RSASIG)) != POLICY_RSASIG)
+#else
+	    if ((policy & (POLICY_PSK | POLICY_OPENSSL)) != POLICY_OPENSSL)
+#endif
 		diag("only RSASIG is supported for opportunism");
 	    if ((policy & POLICY_PFS) == 0)
 		diag("PFS required for opportunism");
@@ -449,14 +504,15 @@
     }
     else
     {
-	/* fill in unspec-unspec as client subnet */
+	/* fill in anyaddr-anyaddr as (missing) client subnet */
 	ip_address cn;
 
-	diagq(unspecaddr(caf, &cn), NULL);
+	diagq(anyaddr(caf, &cn), NULL);
 	diagq(rangetosubnet(&cn, &cn, &this->client), NULL);
     }
 }
 
+
 /* This is a hack for initiating ISAKMP exchanges. */
 
 int
@@ -471,7 +527,7 @@
 	*af_used_by = NULL,
 	*tunnel_af_used_by = NULL;
 
-    memset(&msg, '\0', sizeof(msg));
+    zero(&msg);
     msg.magic = WHACK_MAGIC;
     msg.right.host_port = IKE_UDP_PORT;
 
@@ -484,10 +540,11 @@
     msg.keyval.ptr = NULL;
 
     msg.sa_ike_life_seconds = OAKLEY_ISAKMP_SA_LIFETIME_DEFAULT;
-    msg.sa_ipsec_life_seconds = SA_LIFE_DURATION_DEFAULT;
+    msg.sa_ipsec_life_seconds = PLUTO_SA_LIFE_DURATION_DEFAULT;
     msg.sa_rekey_margin = SA_REPLACEMENT_MARGIN_DEFAULT;
     msg.sa_rekey_fuzz = SA_REPLACEMENT_FUZZ_DEFAULT;
     msg.sa_keying_tries = SA_REPLACEMENT_RETRIES_DEFAULT;
+    msg.block_cypher = FORCE_ENCRYPT_CYPHER_DEFAULT;
 
     msg.addr_family = AF_INET;
     msg.tunnel_addr_family = AF_INET;
@@ -668,6 +725,37 @@
 	    msg.whack_async = TRUE;
 	    continue;
 
+#ifdef OPENSSL
+      case OPT_CERTFILE:
+          if (strlen(optarg) >= FILE_NAME_LIMIT)
+              diagq("certificate file name too long", optarg);
+              strcpy(msg.whack_certfile, optarg);
+        continue;
+
+      case OPT_CERTOPTS:
+          if (strlen(optarg) >= CERT_OPTIONS_LIMIT)
+              diagq("certificate file name too long", optarg);
+              strcpy(msg.whack_certopts, optarg);
+        continue;
+
+      case OPT_PEERFILE:
+          if (strlen(optarg) >= FILE_NAME_LIMIT)
+              diagq("peer certificate file name too long", optarg);
+              strcpy(msg.whack_peerfile, optarg);
+        continue;
+
+      case OPT_KEYFILE:
+          if (strlen(optarg) >= FILE_NAME_LIMIT)
+              diagq("key file name too long", optarg);
+              strcpy(msg.whack_keyfile, optarg);
+        continue;
+
+      case OPT_CERTPATH:
+          if (strlen(optarg) >= PATH_NAME_LIMIT)
+              diagq("certificate path name too long", optarg);
+              strcpy(msg.whack_certpath, optarg);
+        continue;
+#endif
 
 	/* Connection Description options */
 
@@ -737,7 +825,7 @@
 	    if ((cd_seen & LELEM(CD_HOST-CD_FIRST)) == 0)
 		diag("connection missing --host before --to");
 	    msg.left = msg.right;
-	    memset(&msg.right, '\0', sizeof(msg.right));
+	    zero(&msg.right);
 	    msg.right.id = NULL;
 	    msg.right.updown = NULL;
 	    msg.right.host_port = IKE_UDP_PORT;
@@ -746,12 +834,18 @@
 	    continue;
 
 	case CD_PSK:		/* --psk */
+#ifndef OPENSSL
 	case CD_RSASIG:	/* --rsasig */
+#else
+	case CD_OPENSSL:	/* --rsasig */
+#endif
 	case CD_ENCRYPT:	/* --encrypt */
 	case CD_AUTHENTICATE:	/* --authenticate */
 	case CD_COMPRESS:	/* --compress */
 	case CD_TUNNEL:	/* --tunnel */
-	case CD_PFS:	/* -- pfs */
+	case CD_PFS:	/* --pfs */
+	case CD_FAIL_PASS:	/* --pass */
+	case CD_FAIL_DROP:	/* --drop */
 	    msg.policy |= LELEM(c - CD_POLICY_FIRST);
 	    continue;
 
@@ -775,6 +869,20 @@
 	    msg.sa_keying_tries = opt_whole;
 	    continue;
 
+	/* DES support */
+	case CD_FORCE_ENCRYPT_CYPHER:   /* --force_encrypt_cypher <des/3des> */
+	if (strcmp("des", optarg) == 0) {
+	  msg.block_cypher = DES_BLOCK_CYPHER;
+	}
+	if (strcmp("3des", optarg) == 0) {
+	  msg.block_cypher = DES3_BLOCK_CYPHER;
+	}
+	/* else */
+	if ((strcmp("3des", optarg) != 0) && (strcmp("des", optarg) != 0)) {
+	  diag("--force_encrypt_cypher must have a parameter of either 'des' or '3des'");
+	}
+	continue;
+
 	case OPT_KEYID:	/* --keyid <identity> */
 	    msg.whack_key = TRUE;
 	    msg.keyid = optarg;	/* decoded by Pluto */
@@ -862,6 +970,7 @@
      * required information was supplied.
      */
 
+    /* check opportunistic initiation simulation request */
     switch (opts_seen & (LELEM(OPT_OPPO_HERE) | LELEM(OPT_OPPO_THERE)))
     {
     case LELEM(OPT_OPPO_HERE):
@@ -873,6 +982,7 @@
 	break;
     }
 
+    /* check connection description */
     if (opts_seen & LELEM(OPT_CD))
     {
 	if (!LALLIN(cd_seen, LELEM(CD_TO-CD_FIRST)))
@@ -893,6 +1003,10 @@
 
 	if (subnettypeof(&msg.left.client) != subnettypeof(&msg.right.client))
 	    diag("endpoints clash: one is IPv4 and the other is IPv6");
+
+       if (!HAS_IPSEC_POLICY(msg.policy)
+       && (msg.left.has_client || msg.right.has_client))
+           diag("must not specify clients for ISAKMP-only connection");
 
 	msg.whack_connection = TRUE;
     }
diff -bruN freeswan-1.9.orig/pluto/whack.h freeswan-1.9/pluto/whack.h
--- freeswan-1.9.orig/pluto/whack.h	Sun Jan 28 16:03:05 2001
+++ freeswan-1.9/pluto/whack.h	Wed Jun  6 16:10:04 2001
@@ -16,6 +16,10 @@
 
 #include <freeswan.h>
 
+#ifdef OPENSSL
+#include "openssl_defs.h"
+#endif
+
 /*
  * Since the message remains on one host, native representation is used.
  * Think of this as horizontal microcode: all selected operations are
@@ -83,6 +87,14 @@
     enum pubkey_alg pubkey_alg;
     chunk_t keyval;	/* chunk */
 
+#ifdef OPENSSL
+    char whack_certfile[FILE_NAME_LIMIT];
+    char whack_certopts[CERT_OPTIONS_LIMIT];
+    char whack_peerfile[FILE_NAME_LIMIT];
+    char whack_keyfile[FILE_NAME_LIMIT];
+    char whack_certpath[PATH_NAME_LIMIT];
+#endif
+
     /* for WHACK_ROUTE: */
     bool whack_route;
 
@@ -110,6 +122,10 @@
 
     /* for WHACK_SHUTDOWN */
     bool whack_shutdown;
+
+    /* for des type to use */
+    lset_t block_cypher;
+
 
     /* space for strings (hope there is enough room):
      * Note that pointers don't travel on wire.
diff -bruN freeswan-1.9.orig/pluto/x_sobj.c freeswan-1.9/pluto/x_sobj.c
--- freeswan-1.9.orig/pluto/x_sobj.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/x_sobj.c	Wed May 16 10:57:20 2001
@@ -0,0 +1,36 @@
+#ifdef OPENSSL
+#include "x_sobj.h"
+
+IMPLEMENT_STACK_OF(X509_OBJECT)
+
+X509_OBJECT *
+X509_OBJECT_new( const int type, void *p )
+{
+  X509_OBJECT *ret = Malloc(sizeof(X509_OBJECT));
+
+  if (ret == NULL) return ret;
+  switch(type) {
+  case X509_LU_X509:
+    ret->type = type;
+    ret->data.x509 = (X509 *)p;
+    break;
+  case X509_LU_CRL:
+    ret->type = type;
+    ret->data.crl = (X509_CRL *)p;
+    break;
+  default: /* Unknown type */
+    Free((char *)ret);
+    ret = NULL;
+    break;
+  }
+  return ret;
+}
+
+void
+X509_OBJECT_free(X509_OBJECT *x)
+{
+  if (!x) return;
+  X509_OBJECT_free_contents(x);
+  Free((char *)x);
+}
+#endif /* OPENSSL */
diff -bruN freeswan-1.9.orig/pluto/x_sobj.h freeswan-1.9/pluto/x_sobj.h
--- freeswan-1.9.orig/pluto/x_sobj.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/x_sobj.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,12 @@
+#ifndef X_SOBJ_H
+#define X_SOBJ_H
+
+#include <openssl/x509.h>
+#include <openssl/x509_vfy.h>
+
+DECLARE_STACK_OF(X509_OBJECT)
+
+X509_OBJECT *X509_OBJECT_new( const int type, void *ptr );
+void X509_OBJECT_free(X509_OBJECT *x);
+
+#endif
diff -bruN freeswan-1.9.orig/pluto/xmap.c freeswan-1.9/pluto/xmap.c
--- freeswan-1.9.orig/pluto/xmap.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap.c	Wed May 16 10:57:20 2001
@@ -0,0 +1,401 @@
+#ifdef OPENSSL
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <sys/stat.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <openssl/stack.h>
+#include <openssl/asn1.h>
+#include <openssl/safestack.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+
+#include "x_sobj.h"
+#include "xmap_file.h"
+#include "xmap_dir.h"
+#include "xmap_db.h"
+#include "xmap_ldap.h"
+#include "xmap.h"
+
+#include <freeswan.h> /* needed by constants.h */
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+
+static XMAP_METHOD_LIST *xmth = NULL;
+
+XMAP *XMAP_new(const char *spec);
+STACK_OF(X509_OBJECT) *
+XMAP_lookup( XMAP *xm, const int type, const char *index, void *p );
+void XMAP_free(XMAP *xm);
+void XMAP_dump(XMAP *xm);
+
+int
+XMAP_register(XMAP_METHOD *meth)
+{
+  XMAP_METHOD_LIST *p;
+  int found;
+
+  for(p=xmth,found=0; ((!found) && (p)); p=p->next)
+    if (strcasecmp(meth->prefix, p->meth->prefix) == 0) found=1;
+
+  if (found) {
+    return 0;
+  } else {
+    p = malloc(sizeof(XMAP_METHOD_LIST));
+    if (p) {
+      p->next = xmth;
+      p->meth = meth;
+      xmth = p;
+    } else
+      return 0;
+  }
+  return 1;
+}
+
+void
+XMAP_METHOD_LIST_free( void )
+{
+  XMAP_METHOD_LIST *p, *q;
+
+  for(p=xmth; p;) {
+    q = p->next;
+    free(p);
+    q = p;
+  }
+}
+
+int
+XMAP_unregister(const char *prefix)
+{
+  XMAP_METHOD_LIST *p, *q;
+  int found;
+
+  for(p = xmth, found = 0; ((!found) && (p)); )
+    if (strcasecmp(p->meth->prefix, prefix) == 0)
+      found = 1;
+    else
+      p=p->next;
+
+  if (!found)
+    return 0;
+  else {
+    if ( p == xmth ) {
+      xmth = xmth->next;
+      free(p);
+    } else {
+      for(q = xmth; q->next != p; q = q->next);
+      q->next = p->next;
+      free(p);
+    }
+  }
+  return 1;
+}
+
+XMAP *
+XMAP_new(const char *spec)
+{
+  XMAP *ret;
+  char *s;
+
+  if ((ret = malloc(sizeof(XMAP))) == NULL) goto end;
+  if ((ret->spec = strdup(spec)) == NULL) goto end;
+  ret->methp = NULL;
+
+  if ((s = strchr(spec, DICT_SEPARATOR)) == NULL) {
+    log("No type prefix");
+  } else {
+    int l = (int)(s - spec) + 1;
+    XMAP_METHOD_LIST *p;
+    int found;
+
+    for(p=xmth, found = 0; ((!found) && (p));) {
+      if (strncasecmp(p->meth->prefix, spec, l-1) == 0)
+	found = 1;
+      else
+	p = p->next;
+    }
+
+    if (found) {
+      ret->pmap = p->meth->new(&s[1]);
+      if (! ret->pmap) goto end;
+      ret->methp = p;
+    } else {
+      log("Unknown map type spec: %s", spec);
+      goto end;
+    }
+  }
+  return ret;
+ end:
+  if (ret->spec) free(ret->spec);
+  if (ret) free(ret);
+  return NULL;
+}
+
+static int
+check_methp(XMAP *xm)
+{
+  XMAP_METHOD_LIST *p;
+
+  for(p = xmth; p; p = p->next)
+    if (xm->methp == p) {
+      return 1;
+    }
+
+  return 0;
+}
+
+STACK_OF(X509_OBJECT) *
+XMAP_lookup( XMAP *xm, const int type, const char *index, void *p )
+{
+  if ((!xm) || (!check_methp(xm)) || (! xm->methp->meth->lookup) )
+  {
+    return NULL;
+  }
+  return xm->methp->meth->lookup(xm->pmap, type, index, p);
+}
+
+void
+XMAP_free(XMAP *xm)
+{
+  if (!xm) return;
+  if (!xm->pmap) return;
+  if (!check_methp(xm)) return;
+  if (xm->methp->meth->free) xm->methp->meth->free(xm->pmap);
+  if (xm->spec) free(xm->spec);
+  free(xm);
+}
+
+void
+XMAP_dump(XMAP *xm)
+{
+  if (! xm->pmap) return;
+  if (!check_methp(xm)) return;
+  if (! xm->methp->meth->dump) return;
+  xm->methp->meth->dump(xm->pmap);
+}
+
+int
+X509_subjAltName_check_dns(X509 *x, const char *dns)
+{
+  int i, loc, ret;
+  X509_EXTENSION *ext;
+  u_char *p;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  GENERAL_NAME *gn;
+
+  ret = 0;
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) >= 0) {
+    if ((ext = X509_get_ext(x, loc)) != NULL) {
+      p = ext->value->data;
+      d2i_GENERAL_NAMES(&nsk, &p, ext->value->length);
+      if (nsk) {
+	for(i=0; i < sk_GENERAL_NAME_num(nsk); i++) {
+	  gn = sk_GENERAL_NAME_value(nsk, i);
+	  
+	  if (gn->type == GEN_DNS) {
+	    if (strncasecmp(dns, gn->d.ia5->data, gn->d.ia5->length) == 0) {
+	      ret = 1;
+	      break;
+	    }
+	  }
+	}
+	sk_GENERAL_NAME_free(nsk);
+	nsk = NULL;
+      }
+    }
+  }
+  return ret;
+}
+
+int
+X509_subjAltName_check_ip(X509 *x, const struct in_addr ip)
+{
+  int i, loc, ret;
+  X509_EXTENSION *ext;
+  u_char *p;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  GENERAL_NAME *gn;
+
+  ret = 0;
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) >= 0) {
+	if ((ext = X509_get_ext(x, loc)) != NULL) {
+		p = ext->value->data;
+		d2i_GENERAL_NAMES(&nsk, &p, ext->value->length);
+		if (nsk) {
+			for(i=0; i < sk_GENERAL_NAME_num(nsk); i++) {
+				gn = sk_GENERAL_NAME_value(nsk, i);
+	  
+				if (gn->type == GEN_IPADD) {
+					if (memcmp(&ip.s_addr, gn->d.ip->data, gn->d.ip->length) == 0) {
+						ret = 1;
+						break;
+					}
+				}
+			}
+			sk_GENERAL_NAME_free(nsk);
+			nsk = NULL;
+		}
+ 	 }
+  }
+  return ret;
+}
+
+
+/* some cloning procedures. needed to unshare connection
+ * for road warrior support.
+ */
+
+STACK_OF(XMAP) 
+*clone_sk_XMAP ( STACK_OF(XMAP) *sk_xm )
+{
+	/* declare new stack */
+	STACK_OF(XMAP) *temp_sk_xm;
+	int i;
+
+	/* clone contents of stack. Memory pointers stay the same
+	 * so further cloning for each sub-structure is needed.
+	 *
+	 * typedef struct stack_st
+	 * {
+	 *  int num;
+	 *  char **data;
+	 *  int sorted;
+	 *  int num_alloc;
+	 *  int (*comp)();
+	 * } STACK;
+	 */
+
+	temp_sk_xm = sk_XMAP_new_null();
+	for (i=0; i<sk_XMAP_num(sk_xm); i++) {
+	  XMAP *xm = sk_XMAP_value(sk_xm, i);
+
+	  /* clone XMAP */
+	  xm = clone_XMAP(xm);
+
+	  sk_XMAP_push(temp_sk_xm, xm);
+	}
+
+	/* return the newly cloned STACK_OF(XMAP) */
+	return temp_sk_xm;     
+}
+
+XMAP 
+*clone_XMAP ( XMAP *xm )
+{
+	XMAP *temp_xm;
+	/* cloning of XMAP....... 
+	 * typedef struct _xmap_st {
+	 *   char *spec;
+	 *   void *pmap;
+	 *   XMAP_METHOD_LIST *methp;
+	 * } XMAP;
+	 */
+
+	temp_xm = malloc(sizeof(XMAP));
+
+	temp_xm->spec = clone_str(xm->spec, "cloning XMAP spec");
+	temp_xm->pmap = clone_XMAP_pmap(xm->pmap, xm->spec);
+
+	/* let's try without cloning the XMAP_METHOD_LIST, so that
+	 * check_methp will work.
+	 * temp_xm->methp = clone_XMAP_METHOD_LIST(xm->methp);
+	 */ 
+	temp_xm->methp = xm->methp;
+
+	return temp_xm;
+}
+
+XMAP_METHOD_LIST 
+*clone_XMAP_METHOD_LIST ( XMAP_METHOD_LIST *xm_l )
+{
+	XMAP_METHOD_LIST *temp_xm_l;
+
+	/*
+	 * typedef struct _xmap_method_list_st {
+	 *   XMAP_METHOD *meth;
+	 *   struct _xmap_method_list_st *next;
+	 * } XMAP_METHOD_LIST;
+	 *
+	 * Recursive cloning...
+	 */
+
+	temp_xm_l = malloc(sizeof(XMAP_METHOD_LIST));
+	if (xm_l->next) {
+		temp_xm_l->next = clone_XMAP_METHOD_LIST(xm_l->next);
+	} else {
+		temp_xm_l->next = NULL;
+	}
+
+	temp_xm_l->meth = clone_XMAP_METHOD(xm_l->meth);
+	return temp_xm_l;
+}
+
+
+XMAP_METHOD
+*clone_XMAP_METHOD ( XMAP_METHOD *xm_m )
+{
+	XMAP_METHOD *temp_xm_m;
+
+	/*
+	 * typedef struct _xmap_method_st {
+	 *   char *prefix;
+	 *     STACK_OF(X509_OBJECT) *(*lookup)( void *this, 
+	 *        const int type, const char *index, void *p );
+	 *   void (*dump)(void *pmap);
+	 *   void (*free)(void *pmap);
+	 *   void *(*new) (const char *spec);
+	 * } XMAP_METHOD;
+	 */
+
+
+	temp_xm_m = malloc(sizeof(XMAP_METHOD));
+
+	if (xm_m->prefix) {
+		temp_xm_m->prefix = clone_str(xm_m->prefix, 
+			"cloning XMAP_METHOD prefix");
+	}
+
+	/* don't clone the following */
+	temp_xm_m->lookup = xm_m->lookup;
+	temp_xm_m->dump = xm_m->dump;
+	temp_xm_m->free = xm_m->free;
+	temp_xm_m->new = xm_m->new;
+
+	return temp_xm_m;
+}
+
+void
+*clone_XMAP_pmap ( void *pmap, char *spec )
+{
+	void *t_pmap;
+	char *s;
+	int l, found;
+	XMAP_METHOD_LIST *p;
+
+	s = strchr(spec, DICT_SEPARATOR);
+	l = (int)(s - spec) + 1;
+
+	for(p=xmth, found = 0; ((!found) && (p));) {
+	  if (strncasecmp(p->meth->prefix, spec, l-1) == 0) {
+	    found = 1;
+	   } else {
+	    p = p->next;
+           }
+	}
+
+	if (found) {
+	  t_pmap = p->meth->new(&s[1]);
+	}
+
+	return t_pmap;
+}
+
+
+IMPLEMENT_STACK_OF(XMAP)
+#endif /* OPENSSL */
diff -bruN freeswan-1.9.orig/pluto/xmap.h freeswan-1.9/pluto/xmap.h
--- freeswan-1.9.orig/pluto/xmap.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/xmap.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,62 @@
+#ifndef XMAP_H
+#define XMAP_H
+
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+#include <openssl/x509_vfy.h>
+
+#include "x_sobj.h"
+
+typedef struct _xmap_method_st {
+  char *prefix;
+    STACK_OF(X509_OBJECT) *(*lookup)( void *this, const int type, const char *index, void *p );
+  void (*dump)(void *pmap);
+  void (*free)(void *pmap);
+  void *(*new) (const char *spec);
+} XMAP_METHOD;
+
+typedef struct _xmap_method_list_st {
+  XMAP_METHOD *meth;
+  struct _xmap_method_list_st *next;
+} XMAP_METHOD_LIST;
+
+typedef struct _xmap_st {
+  char *spec;
+  void *pmap;
+  XMAP_METHOD_LIST *methp;
+} XMAP;
+
+DECLARE_STACK_OF(XMAP)
+
+#ifndef DICT_SEPARATOR
+#define DICT_SEPARATOR ':'
+#endif
+
+#define XMAP_UNKNOWN_TYPE 0
+#define XMAP_FILE_TYPE    1
+#define XMAP_DIR_TYPE     2
+#define XMAP_DB_TYPE      3
+
+int XMAP_register(XMAP_METHOD *meth);
+void XMAP_METHOD_LIST_free( void );
+int XMAP_unregister(const char *prefix);
+
+int X509_subjAltName_check_dns(X509 *x, const char *dns);
+int X509_subjAltName_check_ip(X509 *x, const struct in_addr in);
+
+XMAP *XMAP_new(const char *spec);
+STACK_OF(X509_OBJECT) *XMAP_lookup( XMAP *xm, const int type, const char *index, void *p );
+void XMAP_free(XMAP *xm);
+void XMAP_dump(XMAP *xm);
+
+extern STACK_OF(XMAP) *clone_sk_XMAP ( STACK_OF(XMAP) *sk_xm );
+extern XMAP *clone_XMAP ( XMAP *xm );
+extern void *clone_XMAP_pmap ( void *pmap, char *spec );
+extern XMAP_METHOD_LIST *clone_XMAP_METHOD_LIST ( XMAP_METHOD_LIST *xm_l );
+extern XMAP_METHOD *clone_XMAP_METHOD ( XMAP_METHOD *xm_m );
+
+#endif /* XMAP_H */
